<%@ page import="org.aidworld.aidbase.request.Request" %>
<%@ page import="org.apache.log4j.Logger" %>
<%@ page import="org.apache.log4j.Level" %>
<%@ page import="org.apache.log4j.PatternLayout" %>
<%@ page import="org.apache.log4j.FileAppender" %>
<%@ page import="mumail.net.SmtpClient" %>
<%@ page import="java.util.Properties" %>
<%@ page import="org.aidworld.aidbase.util.Utils" %>
<%@ page import="org.aidworld.aidbase.webui.util.WebUtils" %>
<%@ page import="java.io.*" %>
<%
    // Get the attributes
	String    errorwriter_page_url  = null;
	Throwable errorwriter_exception = null;
	
	String errorwriter_report = "";

	try {
		errorwriter_page_url =
			(String)   ( request.getAttribute("original.url.full") );
		if (errorwriter_page_url == null) {
			errorwriter_page_url = request.getParameter(
				WebUtils.getAidbaseUrlParam());
		}
    	errorwriter_exception = 
    		(Throwable)( request.getAttribute("exception") );
 	} catch (Throwable t) {
 		errorwriter_report += "(Error decoding error information: "+t+")\n";
 	}

	errorwriter_report += "Page: ";
 		
	if (errorwriter_page_url != null) {
		errorwriter_report += errorwriter_page_url;
	} else {
		errorwriter_report += "(null)";
	}
	
	errorwriter_report += " GIVES ERROR: ";
	
	if (errorwriter_exception != null) {
		errorwriter_report += errorwriter_exception.toString();
	} else {
		errorwriter_report += "(null)";
	}
	
    final Logger logger = Logger.getLogger("errorwriter");
    logger.setLevel((Level) Level.DEBUG);
	
	String logfile = Utils.getLogsDirectory()+"/error_reports";

	try {
		PatternLayout layout = new PatternLayout("%d{dd/MM HH:mm:ss} %-5p %c{1}: %m%n");
		FileAppender appender = new FileAppender(layout, logfile);
	    
	    logger.addAppender(appender);
		logger.error(errorwriter_report);
	    logger.removeAppender(appender);
	} 
	catch (Exception e)
	{
    	%>
    		<p><small>
    		Sorry, could not log the error to <%= logfile %>:
    		<%= e.getMessage() %>. The administrator may need to change the 
    		<code>application.logsdirectory</code> property in the
    		<code>application.properties</code> file.
    		</small></p>
    	<%
	}

	try {
		Properties props = Utils.getAppProps();
		final String smtphost = props.getProperty("application.smtphost");
		final String smtpport = props.getProperty("application.smtpport");	
		final String from     = props.getProperty("application.from");
		final String to       = props.getProperty("application.to");
	    int smtpportint = 0;

		if (smtphost == null || smtphost.equals(""))
			throw new Exception(
				"<code>application.smtphost</code> is not configured");	

		if (smtpport == null || smtpport.equals(""))
			throw new Exception(
				"<code>application.smtpport</code> is not configured");	

	    try {
	    	smtpportint = Integer.parseInt(smtpport);
	    } catch (Exception x) {
	    	throw new Exception(
	    		"<code>application.smtpport</code> is not a valid integer");
	    }

	    if (smtpportint < 1 || smtpportint > 65535)
	    	throw new Exception(
	    		"<code>application.smtpport</code> must be a " +
	    		"valid IPv4 port number, between 1 and 65535");
	    	
		if (from == null || from.equals(""))
			throw new Exception(
				"<code>application.from</code> is not configured");	
				
		if (to == null || to.equals("")) 
			throw new Exception(
				"<code>application.to</code> is not configured");

		logger.debug("sending error report by mail to "+to+
			" using "+smtphost+"...");
			
		class ErrorReportThread extends Thread
		{
			private Logger logger;
			private String report, smtphost, from, to;
			private int smtpport;
			
			public ErrorReportThread(String report, Logger logger,
				String smtphost, int smtpport, String from, String to) {
				super("ErrorReportThread");
				this.report   = report;
				this.logger   = logger;
				this.smtphost = smtphost;
				this.smtpport = smtpport;
				this.from     = from;
				this.to       = to;
			}
			
			public void run()
			{
				try 
				{
			   		SmtpClient smtp = new SmtpClient(smtphost, smtpport);
					smtp.submitMail(from, to, "[Error report]", report, "UTF-8");
					smtp.Disconnect();
					logger.debug("mail sent");
				} 
				catch (Exception e)
				{
					logger.warn("failed to send mail: "+e.toString());
				}
			}
		}
		
		Thread t = new ErrorReportThread(errorwriter_report, logger, 
			smtphost, smtpportint, from, to);
		t.start();	
	} 
	catch (Exception ex2) 
	{
    	%>
    		<p><small>
    		Sorry, could not send error report by e-mail, because
    		the webmaster has not correctly configured the
    		e-mail settings in <code>application.properties</code>
    		(<%= ex2.getMessage() %>)</small></p>
    	<%
    }
%><%= Utils.getLogsDirectory() %>