<%@ page import="java.io.PrintWriter" %>
<%@ page import="java.io.IOException" %>
<%@ page import="java.net.URL" %>
<%@ page import="org.aidworld.aidbase.webui.util.WebUtils" %>
<%@ page import="org.aidworld.aidbase.core.Version" %>

<%
/* ------------------------------------------------------------------------
 * Aidbase simplifies HTML pages to reduce bandwidth usage, et cetera.
 * Copyright (C) 2002-2004 Aidworld Humanitarian ICT, Cambridge, UK. 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 * General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 * This software is intended to be as accessible as possible. If acceptance 
 * of this license conflicts with your interests, please contact us to 
 * discuss how we might be able to accommodate your requirements. 
 * 
 * Please look at our website, http://www.aidworld.org, to find out more 
 * about our organisation and to read our mission statement. 
 * ------------------------------------------------------------------------
 */
%>
<%--
  - Display an internal error
  -
  - Attributes to pass in:
  -
  -   exception  - The IOException that occurred
  -   request    - The aidbase Request object
  -
  --%>
<%
    // Get the attributes
    String page_url = (String)   request.getAttribute("original.url.full");
    
    // Get the aidbase url prefix using the WebUtils class    
    String aidbasePrefix = "page?" + WebUtils.getAidbaseUrlParam() + "=";

    // Get the requested url
    String baseUrl = "";
    
    if (page_url != null)
    	baseUrl = page_url.replaceFirst("^(.*://[^/]*).*", "$1");
    
%>
<html>
<head>
<title><%= Version.getName() %> Error</title>
<%= WebUtils.getPageHeadHtml() %>
</head>
<body>
<%= WebUtils.getPageHeader(page_url) %>

<h3>File Not Found</h3>

<p>Sorry, but we couldn't find the page you requested: </p>

	<ul><li><a href="<%= page_url %>"><%= page_url %></a></li></ul>

<p>This could be because the page is not currently available, 
or it could be a fault with <%= Version.getName() %> or with the website.</p>

<p>You could try the following:</p>

<ul>
    <li>Reload this page and see if it works this time</li>
    <li>Check that the address above is correct</li>
    <li>Press the 'back' button on your browser and try another link</li>
    <li>Click on the link above to view the site directly, bypassing 
    	<%= Version.getName() %></li>
    <li>Go to the <a href="<%= aidbasePrefix + baseUrl %>">original site's 
    	home page</a></li> and try a different path
    <li>Go back to the 
    	<b><a href="<%= WebUtils.getContextPath() %>">
    	<%= Version.getName() %> main page</a></b>
    	and search for another page</li>
</ul>

<%@ include file="errorwriter.jsp" %>
<%-- Debug.jsp will only output html if the log level is set to debug --%>
<%@ include file="debug.jsp" %>

<%= WebUtils.getPageFooter() %>