<%@ page import="java.io.PrintWriter" %>
<%@ page import="org.aidworld.aidbase.core.Version" %>
<%@ page import="org.aidworld.aidbase.webui.util.WebUtils" %>
<%
/* ------------------------------------------------------------------------
 * Aidbase simplifies HTML pages to reduce bandwidth usage, et cetera.
 * Copyright (C) 2002-2004 Aidworld Humanitarian ICT, Cambridge, UK. 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 * General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 * This software is intended to be as accessible as possible. If acceptance 
 * of this license conflicts with your interests, please contact us to 
 * discuss how we might be able to accommodate your requirements. 
 * 
 * Please look at our website, http://www.aidworld.org, to find out more 
 * about our organisation and to read our mission statement. 
 * ------------------------------------------------------------------------
 */
%>
<%--
  - Aidbase is uable to filter the requested page - suggest an alternative url.
  -
  - Attributes to pass in:
  -   exception   - The exception that occurred - this could be null
  -   message     - A short user friendly description of the error
  -   alturl      - An alternative url
  --%>

<%
    // Get the attributes
    String message     = (String)(request.getAttribute("message"));
    String alturl      = (String)(request.getAttribute("alturl"));
    String originalUrl = (String)(request.getAttribute("original.url.full"));
%>

<html>
<head>
<title><%= Version.getName() %></title>
<%= WebUtils.getPageHeadHtml() %>
</head>
<body>
<%= WebUtils.getPageHeader(originalUrl) %>

<h3>Unable to filter</h3>

<p>Sorry, we could not filter the requested page:</p>

	<ul><li><a href="<%= originalUrl %>"><%= originalUrl %></a></li></ul>

<p>This could be because the page is not currently available, 
or it could be a fault with <%= Version.getName() %>.</p>

<p>You could try the following:</p>

<ul>
    <li>Reload this page and see if it works this time</li>
    <li>Press the 'back' button on your browser and try another link</li>
    <li>Click on the link above to view the site directly, bypassing 
    	<%= Version.getName() %></li>
    <li>Go back to the 
    	<b><a href="<%= WebUtils.getContextPath() %>"><%= Version.getName() %> main page</a></b>
    	and search for another page</li>
</ul>

<hr/>

<h4>Error Details</h4>

<%
if (message!=null){
%>
<p><%= message.replaceAll("<","&lt;").replaceAll(">","&gt;") %></p>
<%
}
%>

<%@ include file="errorwriter.jsp" %>
<%-- Debug.jsp will only output html if the log level is set to debug --%>
<%@ include file="debug.jsp" %>

<%= WebUtils.getPageFooter() %>
