<%@ page import="org.aidworld.aidbase.webui.util.WebUtils" %>
<%@ page import="org.aidworld.aidbase.core.Version" %>


<html><head><title>loband - instructions</title>
<%= WebUtils.getPageHeadHtml() %>
</head>

<body>

<%= WebUtils.getPageHeader(null) %>

<h2>Instructions</h2>

<p><h3>Basic Concepts</h3>

<p>
	<em><%= Version.getName() %></em> is a service that simplifies web pages, in order to 
	make them download faster over slow Internet connections.
</p>

<p>
	To use the service, type the URL (web address) of the page you want
	to visit into the grey bar at the top of the page, and click the "Go" 
	button. For example:
</p>

<table class="aidbar">
	<tr class="aidbar">
		<td class="ableft">&gt;(<u><%= Version.getName() %></u>)-</td>
		<td class="abmid">
			<input class="aburl" name="_ab_url" 
				value="http://www.mywebsite.org" type="text">
			<input name="_ab_request" value="Go" type="submit">
		</td>
		<td class="abright">&nbsp;</td>
	</tr>
</table>

<p>
	Once you start browsing through loband, this grey bar will be available 
	at the top of each page.
</p>

<h3>What is a simplified page?</h3>

<p>
	The simplified page viewed through <%= Version.getName() %> will contain the same text
	information as the original. The formatting of the simplified page will 
	be as similar to the original as possible, with colours and images 
	removed. On certain pages you may find that things have moved around 
	to some degree.
</p>

<p>
	It is possible that you will want to view something that <%= Version.getName() %> filters 
	out. Images contained in the original page are replaced by links 
	containing an 'i' in square brackets, e.g. <u>[i-MainMap]</u> or 
	<u>[i]</u>. In either case, by clicking on the link, the original image 
	can be viewed. It is also possible to view the entire original page using 
	the <u>original</u> link on the grey bar at the top of the page.
</p>

<h3>What if something's wrong with the page?</h3>

<p>
	We are keen to make as many pages accessible as possible.
	On a small number of pages, you may find that the simplified page is not 
	as usable as the original version. 
	If this happens, you can let us know about the problem by using the 
	<u>report error</u> link on the top grey bar, which will send us an alert 
	about the page you are trying to view.
</p>
 
<p>
	If you are unable to use a simplified page, you can use the 
	<u>original</u> link on the top grey bar to view the original page.
</p>

<h3>Reporting a problem</h3>

<p>
	If you choose to let us know about a problem by clicking on the 
	<u>report error</u> link, you will be given the option to tell us more 
	details about the problem you had - this information can be useful to 
	us in finding and fixing the problem. You will also be given the option 
	to tell us your email address, which will allow us to respond personally 
	to your error report. Although time pressures mean that we cannot 
	guarantee to respond to each error report, we constantly use feedback 
	from our users to make improvements to the <%= Version.getName() %> service.
</p>

<p>
	Aidworld will not use your email address for any purpose other than
	responding to feedback, and will not disclose your email address to any 
	third party.
</p>

<p><a href="<%= WebUtils.getApplicationUrl() %>">back to main page</a></p>

<%= WebUtils.getPageFooter() %>

</body></html>