/* ------------------------------------------------------------------------
 * Aidbase simplifies HTML pages to reduce bandwidth usage, et cetera.
 * Copyright (C) 2002-2004 Aidworld Humanitarian ICT, Cambridge, UK. 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 * General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 * This software is intended to be as accessible as possible. If acceptance 
 * of this license conflicts with your interests, please contact us to 
 * discuss how we might be able to accommodate your requirements. 
 * 
 * Please look at our website, http://www.aidworld.org, to find out more 
 * about our organisation and to read our mission statement. 
 * ------------------------------------------------------------------------
 */

package org.aidworld.aidbase.document;

import java.util.Map;


/**
 * Represents a binary document.
 */
public class BinaryDocument implements Document {

    byte[] m_bytes;
    private Map attributes =null;
    
    /**
     * Constructor without attributes
     * 
     * @param bytes	The content of the file
     */
    public BinaryDocument(byte[] bytes){
        m_bytes = bytes;
    }
    
    /**
     * Constructer with attributes
     * 
     * @param bytes			The conent of the file
     * @param attributes	the attributes of the file
     */
    public BinaryDocument(byte[] bytes, Map attributes){
        m_bytes = bytes;
        this.attributes = attributes;
    }

    /**
     * Returns the content of the document
     * 
     * @return The content
     */
    public byte[] getBytes(){
        return m_bytes;
    }
    
    /**
     * Returns the attributes of the document
     * 
     * @return The attributes
     */
    public Map getAttributes(){
        return attributes;
    }
    
    /**
     * Returns "Binary Document" 
     * 
     * @return "Binary document"
     */
    public String toString(){
        return "Binary Document";
    }
}





