package org.aidworld.aidbase.error;


/**
* Thrown when the ultimate web server breaks the HTTP protocol
* in some way, e.g. by sending a malformed response or disconnecting
* while sending response data.
* 
* @author chris
*/
public class ServerTimeoutException extends DocumentException {
	/**
	 * Create a ServerTimeoutException with just a message
	 * 
	 * @param message	The error message
	 */
   public ServerTimeoutException (String message) {
       super(message);
   }

   /**
    * Create a ServerTimeoutException with a root cause
    * 
    * @param message	The error message
    * @param cause		The root cause (another exception)
    */
   public ServerTimeoutException (String message, Throwable cause){
       super(message, cause); 
   }

}

