/* ------------------------------------------------------------------------
 * Aidbase simplifies HTML pages to reduce bandwidth usage, et cetera.
 * Copyright (C) 2002-2004 Aidworld Humanitarian ICT, Cambridge, UK. 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 * General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 * This software is intended to be as accessible as possible. If acceptance 
 * of this license conflicts with your interests, please contact us to 
 * discuss how we might be able to accommodate your requirements. 
 * 
 * Please look at our website, http://www.aidworld.org, to find out more 
 * about our organisation and to read our mission statement. 
 * ------------------------------------------------------------------------
 */
package org.aidworld.aidbase.factory;

import java.io.FileNotFoundException;
import java.net.NoRouteToHostException;
import java.net.URL;
import java.net.UnknownHostException;

import org.aidworld.aidbase.error.AidbaseException;
import org.aidworld.aidbase.error.InternalFaultException;
import org.aidworld.aidbase.error.ServerProtocolException;
import org.aidworld.aidbase.request.Request;

class TestUrlContents extends URLContents
{
	// private Logger m_log = Logger.getLogger(TestUrlContents.class);

	public static Exception getTestException() {
		Exception e1 = new Exception("e1");
		Exception e2 = new Exception("e2", e1);
		return e2;
	}

	protected TestUrlContents(URL url, Request request)
	throws AidbaseException
	{
		String testName = url.getFile();
		testName = testName.replaceAll(".*/", "");
		this.request = request;
		if (testName.equals("NestedException")) {
			throw new InternalFaultException("NestedException", getTestException());
		} else if (testName.equals("FileNotFoundException")) {
			throw new ServerProtocolException("FileNotFoundException", 
					new FileNotFoundException());
		} else if (testName.equals("UnknownHostException")) {
			throw new ServerProtocolException("UnknownHostException",
					new UnknownHostException());
		} else if (testName.equals("NoRouteToHostException")) {
			throw new ServerProtocolException("NoRouteToHostException",
					new NoRouteToHostException());
		} else {
			throw new InternalFaultException("FileNotFoundException",
					new FileNotFoundException("No such built-in test: "	+ testName));
		}
	}
}