/* ------------------------------------------------------------------------
 * Aidbase simplifies HTML pages to reduce bandwidth usage, et cetera.
 * Copyright (C) 2002-2004 Aidworld Humanitarian ICT, Cambridge, UK. 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 * General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 * This software is intended to be as accessible as possible. If acceptance 
 * of this license conflicts with your interests, please contact us to 
 * discuss how we might be able to accommodate your requirements. 
 * 
 * Please look at our website, http://www.aidworld.org, to find out more 
 * about our organisation and to read our mission statement. 
 * ------------------------------------------------------------------------
 */
package org.aidworld.aidbase.filter;

import java.io.File;

import org.aidworld.aidbase.core.Timer;
import org.aidworld.aidbase.document.Document;
import org.aidworld.aidbase.error.AidbaseException;
import org.aidworld.aidbase.request.Request;
import org.aidworld.aidbase.util.Utils;
import org.apache.log4j.Logger;

/**
 * @author chris
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class BasicFilter implements Stage {

	protected Logger log = Logger.getLogger(BasicFilter.class);
	
	/**
	 * @see org.aidworld.aidbase.core.Filter#getName()
	 */
	
	public String getName() {
		return getClass().getName().replaceAll(".*\\.", "");
	}
	
	private Stage next = null;

	public void setNextStage(Stage next) {
		this.next = next;
	}

	public Stage getNextStage() {
		return next;
	}

	public Document service(Request request) throws AidbaseException  {
        request.increaseDepth();
        Document doc;
        Timer timer = request.getTimer();
        
        timer.push(next.getName());
        doc = next.service( request );
        timer.pop();

        if (log.isDebugEnabled()) {
			String dumpFileName = new File(
					Utils.getTempDirectory(),
					"aidbase_after-" 
					+ request.getDepth() + "-"
					+ next.getName()+".html").getAbsolutePath();
        	log.debug("writing to file: "+dumpFileName);
        	Utils.dumpFile(dumpFileName, doc.toString());
        }

        request.decreaseDepth();
        return doc;
	}
	
	public final Document filter(Request request, Stage next) 
	throws UnsupportedOperationException {
		throw new UnsupportedOperationException(
				"nobody should override or call this method any more");
		
	}
}
