/*
 * Created on 08-Jun-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.aidworld.aidbase.filter;

import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.net.URLEncoder;

import org.aidworld.aidbase.document.Document;
import org.aidworld.aidbase.error.AidbaseException;
import org.aidworld.aidbase.error.InternalFaultException;
import org.aidworld.aidbase.request.Request;

import com.opensymphony.oscache.base.NeedsRefreshException;
import com.opensymphony.oscache.general.GeneralCacheAdministrator;

/**
 * @author chris
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class CacheFilter extends BasicFilter 
{
	private static GeneralCacheAdministrator cache = 
		new GeneralCacheAdministrator();
	
	/**
	 * Main constructor. Nothing special.
	 */
	public CacheFilter() {
		super();
	}
	
	public static GeneralCacheAdministrator getCache() {
		return cache;
	}
	
	public Document service(Request request) throws AidbaseException  {
		URL url = request.getURL();
		String cacheKey;
		
		try {
			cacheKey = URLEncoder.encode(url.toString(), "UTF-8");
		} catch (UnsupportedEncodingException e) {
			throw new InternalFaultException("Unsupported encoding UTF-8");
		}
		
		int myRefreshPeriod = 1000;
		Document doc;
		
		try {
			// Get from the cache
			doc = (Document)( cache.getFromCache(cacheKey, myRefreshPeriod) );
		} catch (NeedsRefreshException nre) {
			try {
				doc = super.service(request);
				cache.putInCache(cacheKey, doc);
			} catch (AidbaseException e) {
				// We have the current content if we want fail-over.
				doc = (Document)( nre.getCacheContent() );
				// It is essential that cancelUpdate is called if the
				// cached content is not rebuilt
				cache.cancelUpdate(cacheKey);
				throw(e);
			}
		}

		if (doc == null)
		{
			doc = super.service(request);
			cache.putInCache(cacheKey, doc);
		}
		
		return doc;
	}

}
