/* ------------------------------------------------------------------------
 * Aidbase simplifies HTML pages to reduce bandwidth usage, et cetera.
 * Copyright (C) 2002-2004 Aidworld Humanitarian ICT, Cambridge, UK. 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 * General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 * This software is intended to be as accessible as possible. If acceptance 
 * of this license conflicts with your interests, please contact us to 
 * discuss how we might be able to accommodate your requirements. 
 * 
 * Please look at our website, http://www.aidworld.org, to find out more 
 * about our organisation and to read our mission statement. 
 * ------------------------------------------------------------------------
 */
package org.aidworld.aidbase.filter;

import java.util.Properties;

import org.aidworld.aidbase.document.Document;
import org.aidworld.aidbase.document.HtmlDocument;
import org.aidworld.aidbase.error.AidbaseException;
import org.aidworld.aidbase.request.Request;

/**
 *Javascript thaht goes threw the /script pipeline will end 
 *up in this filter. This filter will set some parameters and then
 *pass it on to the JavaScript rewriter. 
 */
public class JavaScriptFilter extends BasicFilter{
	
	/**
	 * Sets the necessary request parameters, such as "original.host".
	 * And pass the javascript on to the rewriter.
	 * 
	 * @param request	The users request
	 * @param server	The server of the requested URL
	 * @return	The html document
	 */
    public Document service(Request request)
    throws AidbaseException 
	{
		Document document = super.service(request);
		String scriptcontents = document.toString();
		
		Properties params = RuleFilter.setUpParams(request);
		
		/*try{
			params.put("aidbase.application.url",WebUtils.getApplicationUrl());
			params.put("original.host",WebUtils.getBaseUrlHost(originalUrl));
			params.put("base.url.path",WebUtils.getBaseUrlPath(originalUrl));
		}catch(Exception e){}
		*/
		
		
		scriptcontents = JavaScriptRewriter.rewrite(scriptcontents,params);
		
		return new HtmlDocument(scriptcontents, document.getAttributes());
    }
	
}
