/* ------------------------------------------------------------------------
 * Aidbase simplifies HTML pages to reduce bandwidth usage, et cetera.
 * Copyright (C) 2002-2004 Aidworld Humanitarian ICT, Cambridge, UK. 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 * General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 * This software is intended to be as accessible as possible. If acceptance 
 * of this license conflicts with your interests, please contact us to 
 * discuss how we might be able to accommodate your requirements. 
 * 
 * Please look at our website, http://www.aidworld.org, to find out more 
 * about our organisation and to read our mission statement. 
 * ------------------------------------------------------------------------
 */

package org.aidworld.aidbase.filter;

import org.aidworld.aidbase.document.Document;
import org.aidworld.aidbase.error.AidbaseException;
import org.aidworld.aidbase.request.Request;


public class Pipeline extends BasicFilter implements Stage {
	private Stage top;
    // private Logger log = Logger.getLogger(Pipeline.class);

    /**
     * Constructor without any filters
     */
    public Pipeline() {

    }

    public Pipeline(Stage [] stages) {
    	for (int i = 0; i < stages.length - 1; i++) {
    		stages[i].setNextStage(stages[i+1]);
    		
    	}
    	if (stages.length > 0) 
    		top = stages[0];
    	else
    		top = null;
    }

    public void add(Stage newStage) {
    	if (top != null)
    		newStage.setNextStage(top);
    	top = newStage;
    }

    /**
     * TODO : Javadoc
     */
    public Document service (Request request) 
    throws AidbaseException
    {
    	return top.service(request);
    }
    
    public Stage getFirstStage() {
    	return top;
    }
    
    public void setNextStage(Stage next) {
    	Stage s = getFirstStage();
    	while (s.getNextStage() != null) {
    		s = s.getNextStage();
    	}
    	s.setNextStage(next);
    }
}