/* ------------------------------------------------------------------------
 * Aidbase simplifies HTML pages to reduce bandwidth usage, et cetera.
 * Copyright (C) 2002-2004 Aidworld Humanitarian ICT, Cambridge, UK. 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 * General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 * This software is intended to be as accessible as possible. If acceptance 
 * of this license conflicts with your interests, please contact us to 
 * discuss how we might be able to accommodate your requirements. 
 * 
 * Please look at our website, http://www.aidworld.org, to find out more 
 * about our organisation and to read our mission statement. 
 * ------------------------------------------------------------------------
 */
package org.aidworld.aidbase.filter.rulefilter;

import java.util.Properties;

import org.aidworld.aidbase.core.Version;

import com.opensymphony.module.sitemesh.html.Tag;

/**
 * This rule will change the title tag so that it 
 * will have a loband prefix.
 */
public class TitleRule extends AttributeFilterRule {
	private Properties params = null;
	
	/**
	 * Main constructor
	 * 
	 * @param	params	The general properties object which is made in RuleFilter
	 * @param	special	Name of the special site if we are working on one, e.g. "hotmail". 
	 */
    public TitleRule(Properties params,String special) {
        super(new String[]{"title"},params,special);
        this.params = params;
    }
    
    /**
     * This method will add the prefix to the title.
     * 
     * @param tag The title tag
     */
    public void process(Tag tag) {
        super.process(tag);
        params.put("titleProcessed","true");
        if (tag.getType() == Tag.OPEN) {
            context.currentBuffer().append(
            		Version.getShortNameHtml() + " ");
        }
    }
    
}
