/*
 * Created on 27-May-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.aidworld.aidbase.webui.servlet;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Collection;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.aidworld.aidbase.core.Timer;
import org.aidworld.aidbase.document.Document;
import org.aidworld.aidbase.error.DocumentException;
import org.aidworld.aidbase.error.DocumentNotFoundException;
import org.aidworld.aidbase.error.FilterException;
import org.aidworld.aidbase.factory.StandardDocumentFactory;
import org.aidworld.aidbase.filter.BinaryDocumentPipeline;
import org.aidworld.aidbase.filter.Pipeline;
import org.aidworld.aidbase.filter.ScriptDocumentPipeline;
import org.aidworld.aidbase.filter.SimplifyPipeline;
import org.aidworld.aidbase.handler.RequestHandler;
import org.aidworld.aidbase.handler.StandardRequestHandler;
import org.aidworld.aidbase.request.HttpRequest;
import org.aidworld.aidbase.util.CompressCounter;
import org.aidworld.aidbase.util.Utils;
import org.aidworld.aidbase.webui.util.WebUtils;
import org.apache.log4j.Logger;
import org.apache.log4j.NDC;

/**
 * @author chris
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class FilterServlet extends AidbaseServlet {
	private Pipeline binaryPipeline, htmlPipeline, scriptPipeline;
	private static Logger mLOG = Logger.getLogger(FilterServlet.class);
	private CompressCounter mCounter;
	
	public FilterServlet() {
		
		this.scriptPipeline = new ScriptDocumentPipeline(
				new StandardDocumentFactory(false));
		this.binaryPipeline = new BinaryDocumentPipeline(
				new StandardDocumentFactory(true));
		this.htmlPipeline = new SimplifyPipeline(
				new StandardDocumentFactory(false, 
						new HtmlChecker(mLOG)));
		mCounter = CompressCounter.getInstance();
	}
	
	public void destroy() {
		mCounter.shutdown();
		super.destroy();
	}
	
    /** Service the POST request. Overrides doABPost in AidbaseServlet */
    protected final void doABPost(HttpServletRequest request, 
    		HttpServletResponse response)
    throws ServletException, IOException
    {
        doABRequest(request, response, true);
    }

    /** Service the GET request. Overrides doABGet in AidbaseServlet */
    protected final void doABGet(HttpServletRequest request, 
    		HttpServletResponse response)
    throws ServletException, IOException
    {
        // Create a new Aidbase request object.
    	doABRequest(request, response, false);
    }
    
    
    /**
     * This method will execute the Aidbase request. Requests to this Servlet should be
     * of the following type: if one wishes to access, say, www.bbc.co.uk/sports, then
     * the request should be to http://www.loband.org/goLoband/www.bbc.co.uk/sports. If a special
     * port is needed, it should be added as the parameter "_ab_port", e.g.
     * http://www.loband.org/goLoband/www.bbc.co.uk/sports?_ab_port=2718
     * 
     * @param request	The users request
     * @param response	The servers response
     * @param isPost	The method used for the request
     * @throws ServletException	If something goes wrong displaying the jsp page
     * @throws IOException	If the reading of the jsp page goes wrong
     */
    private void doABRequest(HttpServletRequest request, 
    		HttpServletResponse response, boolean isPost)
    throws ServletException, IOException
    {
    	CompressCounter.writetoBuffer(0, 1);
    	HttpRequest abrequest = null;
    	NDC.push(request.getSession().getId().substring(0, 8));
    	
    	try 
		{
    		String name = request.getSession().getId().substring(0, 8);
			abrequest = new HttpRequest(request);		// this does not rewrite any of the headers
    		
    		String requestURI = request.getRequestURI();
    		
    		// get the url the client wants to access
    		int position = requestURI.indexOf(WebUtils.getRealFilterServletPath())
					+ WebUtils.getRealFilterServletPath().length();
    		String urlServer = requestURI.substring(position);
    		if(urlServer.length() > 0)
    			urlServer = urlServer.substring(1);		// removes the '/' at the begining of the url
			Object myMonitor = new Object();
			
			Hashtable h = new Hashtable(abrequest.getParameters());
			
			// creating abrequest from request does not copy the paremeters. the
			// next few lines correct this problem.
			String parameterName;
			String[] value;
			for(Enumeration e = request.getParameterNames(); e.hasMoreElements();)
			{
				parameterName = (String)e.nextElement();
				value = request.getParameterValues(parameterName);
				h.put(parameterName, value);
			}
			
			urlServer = WebUtils.unConvertURLToLobandFormat(urlServer);
			
			String port = null;
			if(h.get(WebUtils.getAidbasePortParam()) != null)
				port = ((String[])h.get(WebUtils.getAidbasePortParam()))[0];
			int whereIsSlash = urlServer.indexOf("/");
			
			// add the port to the url
			if(port != null)
				if(whereIsSlash == -1)
					urlServer += port;
				else
					urlServer = urlServer.substring(0, whereIsSlash)
						+ ":" + port + urlServer.substring(whereIsSlash);
			
			// add 'http://' or 'https://' at the beginning of the url
			if(h.get(WebUtils.getAidbaseSecurityParam()) != null && 
					((String[])h.get(WebUtils.getAidbaseSecurityParam()))[0].equals("yes"))
			{
				urlServer = "https://" + urlServer;
			} else if (h.get(WebUtils.getAidbaseFileParam())!=null)
			{
				urlServer = "file://" + urlServer;
			} else
			{
				urlServer = "http://" + urlServer;
			}
			
			try
			{
				URL url = new URL(urlServer);
			} catch (MalformedURLException e) {
				throw new DocumentNotFoundException("Can not understand the url entered by the user.");
			}

			String[] arrayUrlServer= {urlServer};
			h.put(WebUtils.getAidbaseUrlParam(), arrayUrlServer);
			abrequest.setParameters(h);
			
			Pipeline p = null;
			if(abrequest.getParameter("_ab_type") != null)
			{
				String abtype= ((String[])abrequest.getParameter("_ab_type"))[0];
				if(abtype.equals("binary"))
				{
					p = binaryPipeline;
					abrequest.setRequestType("binary");
				}
				else if(abtype.equals("script"))
				{
					p = scriptPipeline;
					abrequest.setRequestType("script");
				}
				else
				{
					p = htmlPipeline;
					abrequest.setRequestType("page");
				}
			} else {
				{
					p = htmlPipeline;
					abrequest.setRequestType("page");
				}
			}
			
/* use this one when debugging */
			RequestHandler rh = new StandardRequestHandler(name,
					abrequest, isPost, p, myMonitor);
			
/* comment this one out when debugging 
			
			RequestHandler rh = new RetryHandler(name,
					abrequest, isPost, p, myMonitor);
			
			*/
			request.setAttribute("original.url.full", urlServer);
	    	rh.start();

    		int timeout = Utils.getMaxTimeoutMillis() + 2000;
    		    		
	    	synchronized(myMonitor) {
	    		if (timeout == 0)
	    			myMonitor.wait();
	    		else
	    			myMonitor.wait(timeout);
	    	}
	    	
	    	if (!rh.isFinished()) {
	    		mLOG.warn("Request thread timed out, interrupting it");
	    		rh.interrupt();
	    		//request.setAttribute("original.url.full", rh.getURL());
	    		throw new FilterException("timeout waiting for document processing");
	    	}
			
	    	Throwable t = rh.getException();
	    	if (t != null) {
	    		mLOG.warn("Exception thrown by filtering thread: "+t);
	    		throw(t);
	    	}
	    	
	    	URL url = null;
	    	String urlString = rh.getURL();
	    	if (urlString != null) { url = new URL(urlString); }
	    	writeDocumentToClient(rh.getDocument(), url, response);
    	} 
    	catch (Throwable t) 
		{
			try {
				String urlString = null;
				URL url = abrequest.getURL();
				
				if (url != null)
					urlString = url.toString();
				
				if (urlString == null)
					urlString = request.getParameter(
							WebUtils.getAidbaseUrlParam());
						
				if (urlString != null)
					request.setAttribute("original.url.full", urlString);
			} catch (Throwable t2) {
				mLOG.warn("Setting URL in request properties: " + t2);
			}

    		handleException(request, response, t);
    	}
    	finally
		{
    		NDC.remove();
		}
    }
    
    private void writeDocumentToClient(Document doc, URL url,
    		HttpServletResponse response) 
    throws DocumentException, IOException 
	{
    	/*
        String docString;
        docString = doc.toString();
        if (docString == null) {
        	throw new DocumentException("Document.toString() returned no string");
        }
        */

        Map responseHeaders = doc.getAttributes();
        String realm = "";
        String headername ="";
    	int statuscode = 0;

        for (Iterator headers = responseHeaders.keySet().iterator(); 
        	headers.hasNext(); ) 
        {
            String header = (String)(headers.next());

            // don't send the original Content-Length to the client
            if (header.equalsIgnoreCase("Content-Length"))
                continue;

            // 'chunked' transfer encoding headers cause problems, e.g. with cnn
            if (header.equalsIgnoreCase("transfer-encoding"))
                continue;

            if (header.equalsIgnoreCase("WWW-Authenticate"))
            {
            	realm = (String) responseHeaders.get(header);
            	headername = header;
            	statuscode = 401;
            	continue;
            }

            Object value = responseHeaders.get(header);
            mLOG.debug("response header "+header+": "+value);
            if (value instanceof Collection) {
                Object [] values = ( (Collection) value ).toArray();
                for (int n_value = 0; n_value < values.length; n_value++) {
                    response.addHeader(header, (String)( values[n_value] ));
                }
            } else if (value instanceof String) {
            	response.setHeader(header, (String)value);
            } else {
                throw new DocumentException(
                		"found response header whose value "+
						"is neither Collection nor String: "+
						header+": "+value);
            }
        }
        
		if (statuscode == 401) {
			response.setStatus(401);
			if (!realm.equals(""))
			{
				realm = realm.substring(0,realm.length()-1);
				realm = realm + " [" + url.getHost() + "]\"";
				response.setHeader(headername,realm);
			}
		}

		String contentType = (String)( doc.getAttributes().get("content-type") );
		if (contentType == null || contentType.startsWith("text/html"))
		{
			contentType = "text/html; charset=UTF-8";
		}
        response.setContentType(contentType);
        
        Timer timer = new Timer();
        timer.push("writing to client");
        
		// Write the data
        ServletOutputStream out = response.getOutputStream();
        // out.print(docString);
        byte [] docStringOut = doc.getBytes();
        out.write(docStringOut);
        out.flush();
        
        timer.pop();
        
        CompressCounter.writetoBuffer(2, docStringOut.length);
    }

}
