/*
 * Created on 28-Jun-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.aidworld.aidbase.webui.servlet;

import java.io.IOException;
import java.net.URL;
import java.util.Enumeration;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.aidworld.aidbase.webui.util.WebUtils;

/**
 * @author sebastien
 * 
 * This servlet receives request from the main page of loband with the url of the
 * website the client wishes to access as a parameter. It then redirects the client to
 * FilterServlet with the correct url encoding (see the documentation for the
 * doABRequest method of FilterServlet).
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class RedirectServlet extends HttpServlet{
	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws IOException
	{
		String redirectedUrl = getRedirectedUrl(request);
		response.sendRedirect(redirectedUrl);
	}
	
	/**
	 * Takes a request of the type 'http://www.loband.org/redirect?_ab_url=http://www.bbc.co.uk/sports&image=1'
	 * and return a String of the type
	 * 'http://www.loband.org/filter/bbc.co.uk/www/sports'
	 * 
	 * @param request
	 * @return
	 * @throws IOException
	 */
	public String getRedirectedUrl(HttpServletRequest request)
			throws IOException
	{
		String aburl = request.getParameter(WebUtils.getAidbaseUrlParam());
		
		// if some monkey types /loband/page with nothing after it
		// this will lead to the front page being displayed
		if (aburl == null)
			return WebUtils.getContextPath();
		
		//remove all spaces in the input 
		//eg "  http: //  www.  yahoo. co .uk"-->"http://www.yahoo.co.uk"
		aburl=aburl.replaceAll(" ","");
		
		//change to lowercase
		/*
		 * change uppercase HTTP/Https to lowercase
		 * remove double http:// as in "http://http://www.lemonde.fr"
		 */
		Pattern pat=Pattern.compile("http://http://",Pattern.CASE_INSENSITIVE);
		Matcher mat=pat.matcher(aburl);
		if (mat.find()&&mat.start()==0)
			aburl="http://"+aburl.substring(14);
		
		Pattern pat2=Pattern.compile("http://https://",Pattern.CASE_INSENSITIVE);
		Matcher mat2=pat2.matcher(aburl);
		if (mat2.find()&&mat2.start()==0)
			aburl="https://"+aburl.substring(15);
		
		Pattern pat3=Pattern.compile("http://",Pattern.CASE_INSENSITIVE);
		Matcher mat3=pat3.matcher(aburl);
		if (mat3.find()&&mat3.start()==0)
			aburl="http://"+aburl.substring(7);
		
		Pattern pat4=Pattern.compile("https://",Pattern.CASE_INSENSITIVE);
		Matcher mat4=pat4.matcher(aburl);
		if (mat4.find()&&mat4.start()==0)
			aburl="https://"+aburl.substring(8);
		
		
		
		//if it is a https request, redirect to original site
		if (aburl.startsWith("https://"))
		{
			return aburl;
		}
		// create a URL to read the port, if it is specified
		URL url;
		if(!aburl.startsWith("http://") && !aburl.startsWith("https://"))
			url = new URL("http://" + aburl);
		else
			url = new URL(aburl);
		int port = url.getPort();
		String redirectedUrl = WebUtils.getContextPath();
		redirectedUrl += WebUtils.getRealFilterServletPath();
		
		// remove the "http://" or "https://" at the begining of the url
		if(aburl.startsWith("http://"))
			aburl = aburl.substring(7);
		else if(aburl.startsWith("https://"))
			aburl = aburl.substring(8);
		
		boolean bFileMode=false;
		if(aburl.startsWith("file:/"))
		{
			aburl = aburl.substring(6);
			bFileMode=true;
		}
		// remove the port from the url if it was there
		if(port != -1)
			aburl = aburl.replaceFirst(":\\d+", "");
		
		aburl= WebUtils.convertURLToLobandFormat(aburl);
		
		
		redirectedUrl += "/" + aburl;
		
		int q = redirectedUrl.indexOf("?");
		boolean hasQuestionMark = false;
		String sQuestion="?";
		if (q != -1) { hasQuestionMark = true; sQuestion="&";} 
				
		// add the port as a Parameter at the end of the url
		if(port != -1)
		{
			redirectedUrl += sQuestion + WebUtils.getAidbasePortParam()
				+ "=" + port;
			hasQuestionMark = true;
			sQuestion="&";
		}
		
		if(bFileMode)
		{
			redirectedUrl += sQuestion + WebUtils.getAidbaseFileParam();
			hasQuestionMark = true;
		}
			
		// add any other Parameter at the end of the url
		String name, value;
		
		for(Enumeration e = request.getParameterNames(); e.hasMoreElements();)
		{
			name = (String)e.nextElement();
			if(!name.equals(WebUtils.getAidbaseUrlParam()))
			{
				if(!hasQuestionMark)
				{
					redirectedUrl += "?";
					hasQuestionMark = true;
				} else
					redirectedUrl += "&";
				value = request.getParameter(name);
				redirectedUrl += name + "=" + value;
			}
		}
		return redirectedUrl;
	}
}