package org.aidworld.aidbase;

import java.util.Enumeration;

import junit.framework.Test;
import junit.framework.TestResult;
import junit.framework.TestSuite;

/**
 * This is a replacement for TestSuite, which when adding another 
 * TestSuite to it, simply adds all the tests in that TestSuite directly 
 * to itself. This should help Ant to report which actual tests 
 * (not suites) failed.
 * 
 * @author chris
 */
public class MyTestSuite implements Test {
    private TestSuite suite;
    public MyTestSuite(String name)
    {
        suite = new TestSuite(name);
    }
    
    public void run(TestResult result) {
        suite.run(result);
    }
    
    public int countTestCases() {
        return suite.countTestCases();
    }

    public void add(TestSuite otherSuite)
    {
        for (Enumeration t = otherSuite.tests(); t.hasMoreElements(); )
        {
            Test test = (Test)( t.nextElement() );
            suite.addTest(test);
        }
    }
    
    public Test getSuite()
    {
        return suite;
    }
}
