/* ------------------------------------------------------------------------
 * Aidbase simplifies HTML pages to reduce bandwidth usage, et cetera.
 * Copyright (C) 2002-2004 Aidworld Humanitarian ICT, Cambridge, UK. 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 * General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 * This software is intended to be as accessible as possible. If acceptance 
 * of this license conflicts with your interests, please contact us to 
 * discuss how we might be able to accommodate your requirements. 
 * 
 * Please look at our website, http://www.aidworld.org, to find out more 
 * about our organisation and to read our mission statement. 
 * ------------------------------------------------------------------------
 */

package org.aidworld.aidbase;

import junit.framework.Test;
import junit.framework.TestSuite;

import org.aidworld.aidbase.offline.unit.BinaryPipelineTests;
import org.aidworld.aidbase.offline.unit.CookieFilterTest;
import org.aidworld.aidbase.offline.unit.ErrorPageJspTests;
import org.aidworld.aidbase.offline.unit.FeedbackTests;
import org.aidworld.aidbase.offline.unit.JavaScriptTest;
import org.aidworld.aidbase.offline.unit.LobandLayoutTests;
import org.aidworld.aidbase.offline.unit.NonHtmlTest;
import org.aidworld.aidbase.offline.unit.OfflineDocumentSpecs;
import org.aidworld.aidbase.offline.unit.ParserFilterTest;
import org.aidworld.aidbase.offline.unit.PostingTests;
import org.aidworld.aidbase.offline.unit.RedirectTests;
import org.aidworld.aidbase.offline.unit.RelativePathJspTests;
import org.aidworld.aidbase.offline.unit.SimpleHtmlPipelineTest;
import org.aidworld.aidbase.offline.unit.TestStandardDocumentFactory;
import org.aidworld.aidbase.offline.unit.URLTests;
import org.aidworld.aidbase.offline.unit.WebUtilsTests;

/**
 * This test suite runs most (not all) unit tests.
 * @todo fix the name, or make it really run all tests.
 */

public class OfflineTestsFast {

	public static Test suite() throws Exception {
		TestSuite suite =
			new TestSuite("Loband Offline Tests");
		
		suite.addTest(BinaryPipelineTests.suite());
		suite.addTest(CookieFilterTest.suite());
		suite.addTest(ErrorPageJspTests.suite());
		suite.addTest(FeedbackTests.suite());
		suite.addTest(JavaScriptTest.suite());
		// suite.addTest(JRobinTests.suite());
		// suite.addTest(LobandCompressionPerformance.suite());
        suite.addTest(LobandLayoutTests.suite());
		suite.addTest(NonHtmlTest.suite());
		suite.addTest(OfflineDocumentSpecs.suite());
		// suite.addTest(OfflineLocalAnalyserTest.suite());
		suite.addTest(ParserFilterTest.suite());
		suite.addTest(PostingTests.suite());
		suite.addTest(RedirectTests.suite());
		suite.addTest(RelativePathJspTests.suite());
		suite.addTest(SimpleHtmlPipelineTest.suite());
		suite.addTest(TestStandardDocumentFactory.suite());
        suite.addTest(URLTests.suite());
		suite.addTest(WebUtilsTests.suite());
		
		return suite;
	}
}
