/* ------------------------------------------------------------------------
 * Aidbase simplifies HTML pages to reduce bandwidth usage, et cetera.
 * Copyright (C) 2002-2004 Aidworld Humanitarian ICT, Cambridge, UK. 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 * General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 * This software is intended to be as accessible as possible. If acceptance 
 * of this license conflicts with your interests, please contact us to 
 * discuss how we might be able to accommodate your requirements. 
 * 
 * Please look at our website, http://www.aidworld.org, to find out more 
 * about our organisation and to read our mission statement. 
 * ------------------------------------------------------------------------
 */

package org.aidworld.aidbase;

import junit.framework.Test;
import junit.framework.TestSuite;

import org.aidworld.aidbase.specialsites.BBCTests;
import org.aidworld.aidbase.specialsites.GoogleTests;
import org.aidworld.aidbase.specialsites.OnlineDocumentSpecs;
import org.aidworld.aidbase.specialsites.ReliefwebTests;

/**
 * This test suite runs most (not all) unit tests.
 * @todo fix the name, or make it really run all tests.
 * Remark: Hotmail and Yahoo tests have been commented from
 * here since we do not support these sites for the moment.
 * SSL test have been commented from
 * here since we do not support these sites for the moment.
 */

public class SpecialSitesTests {

	public static Test suite() throws Exception {
		TestSuite suite =
			new TestSuite("Loband Online Tests");
		
		// Special Sites Tests
		suite.addTest(OnlineDocumentSpecs.suite());
		
//		suite.addTest(AmazonTests.suite());
		suite.addTest(BBCTests.suite());
		suite.addTest(GoogleTests.suite());
//		suite.addTest(HotmailTests.suite());
//		suite.addTest(PaypalDotComTests.suite());
		suite.addTest(ReliefwebTests.suite());
//		suite.addTest(YahooTests.suite());

		return suite;
	}
}
