/*
 * Created on 16-Mar-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.aidworld.aidbase.offline.unit;

import java.net.URLEncoder;

import junit.framework.Test;
import junit.framework.TestSuite;

import org.aidworld.aidbase.core.BasedTest;
import org.aidworld.aidbase.webui.util.WebUtils;
import org.apache.log4j.Logger;

/**
 * @author chris
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ErrorPageJspTests extends BasedTest {

	public void testDebugJspShowsExceptionCauses() throws Exception
	{
		String targetUrl = WebUtils.getApplicationUrl() +
			WebUtils.getFilterServletPath() + "?" + 
			WebUtils.getAidbaseUrlParam() + "=" +
			URLEncoder.encode("file:/test/NestedException", "UTF-8");
		conversation.setExceptionsThrownOnErrorStatus(false);
		response = conversation.getResponse(targetUrl);
		String body = response.getText();
		
		Logger jspLogger = Logger.getLogger("jsp");
		if (jspLogger.isDebugEnabled())
		{
			assertTrue("missing expected details of outer exception",
					body.matches("(?s).*<p>The exception was:</p>.*" +
							"<p><pre>java.lang.Exception: e2.*" +
							"\tat org.aidworld.aidbase.factory.TestUrlContents" +
							".getTestException\\(TestUrlContents.java:.*"));

			assertTrue("missing expected details of inner exception",
					body.matches("(?s).*<p>Caused by:</p>.*" +
							"<p><pre>java.lang.Exception: e1.*" +
							"\tat org.aidworld.aidbase.factory.TestUrlContents" +
							".getTestException\\(TestUrlContents.java:.*"));
		} 
	}

	public void testFileNotFoundExceptionShouldBeTreatedAsFileNotFound()
	throws Exception
	{
		conversation.setExceptionsThrownOnErrorStatus(false);
		response = getThroughAidbase(
				"file:/test/FileNotFoundException");
		String responseText = response.getText();
		assertTrue("Page response doesn't match File Not Found: "
				+ responseText,	responseText.indexOf("File Not Found") != -1);
	}

	public void testUnknownHostExceptionShouldBeTreatedAsFileNotFound()
	throws Exception
	{
		conversation.setExceptionsThrownOnErrorStatus(false);
		response = getThroughAidbase(
				"file:/test/UnknownHostException");
		String responseText = response.getText();
		assertTrue("Page response doesn't match File Not Found: "
				+ responseText,	responseText.indexOf("File Not Found") != -1);
	}
    
	public void testNoRouteToHostExceptionShouldBeTreatedAsFileNotFound()
	throws Exception
	{
		conversation.setExceptionsThrownOnErrorStatus(false);
		response = getThroughAidbase(
				"file:/test/NoRouteToHostException");
		String responseText = response.getText();
		assertTrue("Page response doesn't match File Not Found: "
				+ responseText,	responseText.indexOf("File Not Found") != -1);
	}
    
//	Removed because the new handling rewriting of urls (to handle cookies better)
//	prevents the malformedurl.jsp page from being called.
//	Remark: in addition, in the previous way of rewriting urls, the
//  malformedurl.jsp page was not called for a url like
//	http://www. bbc.co.uk, even though it clearly is a malformed url!
//public void testMalformedUrlShouldReturnCorrectErrorPage() 
//throws Exception 
//{
//	conversation.setExceptionsThrownOnErrorStatus(false);
//	response = getThroughAidbase("whee:");
//	assertTrue("Didn't get our error page: " + response.getText(), 
//			response.getText().indexOf(
//					"Sorry, but we couldn't understand the address:")
//					!= -1);
//}

    public void testUnknownPagesShouldReturnPageNotFoundErrorPage() 
    throws Exception 
	{
    	response = getThroughAidbase(getAidbaseUrl() 
    			+ "/someBadCharacters");
    	assertTrue("Didn't get our error page" , 
    			response.getText().indexOf(
    					"Sorry, but the page you requested is not on")
						!= -1);
    	
    	response = getThroughAidbase(getAidbaseUrl() 
    			+ "/instruction/someBadCharacters");
    	assertTrue("Didn't get our error page on subdirectory", 
    			response.getText().indexOf(
    					"Sorry, but the page you requested is not on")
						!= -1);
    }

	public static void main(String[] args) {
		junit.textui.TestRunner.run(ErrorPageJspTests.class);
	}

	public static Test suite() {
		return new TestSuite( ErrorPageJspTests.class );
	}

}
