/*
 * Created on 31-Mar-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.aidworld.aidbase.offline.unit;

import java.net.URL;
import java.util.Properties;

import junit.framework.Test;
import junit.framework.TestSuite;

import org.aidworld.aidbase.core.BasedTest;
import org.aidworld.aidbase.filter.JavaScriptRewriter;
import org.aidworld.aidbase.webui.util.WebUtils;

import com.meterware.httpunit.GetMethodWebRequest;

/**
 * @author sebastien
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class JavaScriptTest extends BasedTest {
	
    public void testExternalJavaScriptGoesThroughScriptFilter() throws Exception {
    	response = getTestPageThroughAidbase();
    	String expected = "<script src=\"" + WebUtils.getContextPath() +
		WebUtils.getRealFilterServletPath() + "/"+ WebUtils.getApplicationHost() + "/%20" +
		WebUtils.getContextPath()+
				"/test/test.js?_ab_port=" + WebUtils.getApplicationPort() + "&_ab_type=script\" >";
    	
    	assertTrue("External javascript not redirected through script filter.", 
    			response.getText().indexOf(expected)!= -1);
    }

    public void testJavaScriptAttributeKept() throws Exception {
    	response = getTestPageThroughAidbase();
    	assertTrue("JavaScript attribute removed",
    			response.getText().indexOf("<body onLoad=\"foo()\">") != -1);
    }

    public void testJavaScriptRewriterRewritesLinksProperly() {
		String value = "function test(){ "
			+ "if(window.parent.location.href != \"http://www.dpmms.cam.ac.uk/~sr406/\")"
			+ "window.parent.location.href=\"http://www.dpmms.cam.ac.uk/~sr406/\";}";
		Properties params = new Properties();
		params.put("original.host", "http://www.dpmms.cam.ac.uk");
		params.put("base.url.path", "/~sr406");
		params.put("aidbase.application.url","http://localhost:8090/loband");
		params.put("aidbase.servlet.goLoband.fullPath", "http://localhost:8090/loband/filter");
		
		value = JavaScriptRewriter.rewriteLink(value, params);
    	assertTrue(value, value.indexOf("loband/filter/uk/ac/cam/dpmms/www/%20/~sr406/") != -1);
	}
	
    /**
     * We remove all the code between the parenthesis of every
     * javascript command document.writeln. The next tests checks that
     * this is done properly.
     *
     */
	public void testFindCodeBetweenParenthesisInDocumentWriteln() {
		String value ="document.writeln(');')";
		Properties params = null;
		
		value = JavaScriptRewriter.emptyParenthesis(value, params);
		assertTrue(value.equals("document.writeln()"));
	}

	public void testEmptyBraces() {
		String value ="document.writeln()";
		Properties params = null;
		
		value = JavaScriptRewriter.emptyParenthesis(value, params);
		
		assertTrue(value.equals("document.writeln()"));
	}
	
	public void testEmptyBracesWithQuotes() {
		String value ="document.writeln('')";
		Properties params = null;
		
		value = JavaScriptRewriter.emptyParenthesis(value, params);
		
		assertTrue(value.equals("document.writeln()"));
	}
	
	public void testEmptyBracesWithSomethingReallyHard() {
		String value ="document.writeln('<a href=\"'+url+'\" onMouseOver=\"qq(\\''+title+'\\'); return true\" onMouseOut=\"qq(\\'\\'); return true\" title=\"'+title2+'\" target=\"_top\">'+text+'</a>');";
		Properties params = null;
		
		value = JavaScriptRewriter.emptyParenthesis(value, params);
		
		assertTrue(value.equals("document.writeln();"));
	}

	public void testEmptyBracesOnMoreThanOneLine() {
		String value ="document.writeln(');')\n"
			+ "document.writeln('<a href=\"'+url+'\" onMouseOver=\"qq(\\''+title+'\\'); return true\" onMouseOut=\"qq(\\'\\'); return true\" title=\"'+title2+'\" target=\"_top\">'+text+'</a>');\n"
			+ "document.writeln()\n"
			+ "document.writeln('')\n"
			+ "document.writeln('<a href=\"'+url+'\" onMouseOver=\"qq(\\''+title+'\\'); return true\" onMouseOut=\"qq(\\'\\'); return true\" title=\"'+title2+'\" target=\"_top\">'+text+'</a>');";
		Properties params = null;
		
		value = JavaScriptRewriter.emptyParenthesis(value, params);
		
		assertTrue(value.equals("document.writeln()\n"+"document.writeln();\n"+"document.writeln()\n"+"document.writeln()\n"+"document.writeln();"));
	}

    public void testDocumentWritelnIsRemovedProperly() throws Exception {
        response = getThroughAidbase(WebUtils.getApplicationUrl()
                + "/test/test2.html");
        
        // System.out.println(response.getText());
        assertTrue("document.writeln was not emptied properly",
                response.getText().indexOf("function testWriteln(){document.writeln();}") != -1);
    }

    /**
     * This tests that comments in javascript are removed.
     *
     */
    public void testSimpleCommentsAreRemoved(){
		String value = "/** This method is completely useless\n but I like it.*/\nfunction nothing(){\n"
			+ "document.write(); // useless command\n}";
		String expectedValue = "\nfunction nothing(){\n"
			+ "document.write(); \n}";
		Properties params = null;
		
		value = JavaScriptRewriter.removeComments(value, params);
		assertTrue(value.equals(expectedValue));
	}
	
    /**
     * We remove comments in javascript. Comments are indicated by a '//'.
     * But URLs also contain a '//'. This tests that URLs are not erased by
     * our comment remover. 
     *
     */
	public void testCommentsAreRemovedButNotURLs(){
		String value = "/** This method is not useless\n and I like it.*/\nfunction nothing(){\n"
			+ "document.location.href=\"http://www.gerkinsarecool.org\";// useless command\n}"
			+ "\nvar a=\'<a href=\"http://www.butolivesarebetter.int\">';";
		String expectedValue = "\nfunction nothing(){\ndocument.location.href="
				+"\"http://www.gerkinsarecool.org\";\n}\n"
				+"var a='<a href=\"http://www.butolivesarebetter.int\">';";
		Properties params = null;
		
		value = JavaScriptRewriter.removeComments(value, params);
		// System.out.println(value);
		assertTrue(value.equals(expectedValue));
	}
	
	public void testCommentsAreRemovedWithoutMessingUpJavaScriptOne(){
		String testValue = "<!-- <script>\nfunction nothing(){\n"
			+ " //do nothing\n}\n  // --><script>";
		String value;
		Properties params = null;
		String expectedValue = "<!-- <script>\nfunction nothing(){\n"
			+ " \n}\n  // --><script>";
		value = JavaScriptRewriter.removeComments(testValue, params);
		// System.out.println("testCommentsAreRemovedWithoutMessingUp..1");
		// System.out.println(value);
		assertTrue(value.equals(expectedValue));

	}

	public void testCommentsAreRemovedWithoutMessingUpJavaScriptTwo()
    {
		String testValue = testValue = "<!-- <script>\nfunction nothing(){\n"
			+ " //do nothing\n}\n  // --><script>" + "\n<body> // the body";
		String expectedValue = "<!-- <script>\nfunction nothing(){\n"
			+ " \n}\n  // --><script>" + "\n<body> ";
		Properties params = null;
		String value = JavaScriptRewriter.removeComments(testValue, params);
		// System.out.println("testCommentsAreRemovedWithoutMessingUp..2");
		// System.out.println(value);
		assertTrue(value.equals(expectedValue));
	}
    
    public void testCommentClosedInJavascript() throws Exception
    {
        response = getThroughAidbase(WebUtils.getApplicationUrl()+"/test/nobody.html"); 
        assertTrue("No Close Comment found before javascript tag closed", 
                response.getText().indexOf("//--></script>")!=-1);
    }

    public void testJavaScriptContentType () 
    throws Exception 
    {
        request = new GetMethodWebRequest
            (WebUtils.getApplicationUrl() + "/test/RedirectTest.js");
        
        response = conversation.getResponse( request );
        assertEquals("text/javascript", response.getContentType()); 

        response = getThroughAidbase(WebUtils.getApplicationUrl()+"/test/RedirectTest.js");
        URL x = response.getURL();      
        assertTrue(x.toString().indexOf(WebUtils.getAidbasePipelineParam()+"="+ WebUtils.getAidbaseScriptType()) !=-1); 

    
    }

    public static Test suite() {
		return new TestSuite( JavaScriptTest.class );
	}
}
