/* ------------------------------------------------------------------------
 * Aidbase simplifies HTML pages to reduce bandwidth usage, et cetera.
 * Copyright (C) 2002-2004 Aidworld Humanitarian ICT, Cambridge, UK. 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 * General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 * This software is intended to be as accessible as possible. If acceptance 
 * of this license conflicts with your interests, please contact us to 
 * discuss how we might be able to accommodate your requirements. 
 * 
 * Please look at our website, http://www.aidworld.org, to find out more 
 * about our organisation and to read our mission statement. 
 * ------------------------------------------------------------------------
 */

package org.aidworld.aidbase.offline.unit;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.aidworld.aidbase.core.DocumentSpec;
import org.aidworld.aidbase.webui.util.WebUtils;

public class OfflineLocalAnalyserTest extends TestCase {
	public OfflineLocalAnalyserTest( String name ) {
	    super( name );
	}

	/*
	 * @see TestCase#suite()
	
	public static Test suite() {
		return new TestSuite( LocalAnalyserTest.class );
	}
 */
	/*
	 * @see TestCase#setUp()
	 
	public void setUp() throws Exception {
		super.setUp();
        conversation = new WebConversation();
        request 	 = new GetMethodWebRequest( getAidbaseUrl() + "/analyser/" );
        response 	 = conversation.getResponse( request );
	}

    public void testAnalyserPageLoads() throws Exception {
    	
    	response = conversation.getCurrentPage();
        assertTrue(
                response.getText().indexOf("<p><big><big><b>Aidworld Low-bandwidth" +
                		" Simulator </b></big></big><small>") != -1);
    }
    
    /**
     * text() functions in the page do not work on mozilla browser. Test for this.
     * @throws Exception
   
    public void testNoCallOfTextFuntion() throws Exception {
    	response = conversation.getCurrentPage();
    	assertTrue( response.getText().indexOf("onClick=\"text()\"" ) == -1);
    }
    
    public void testNoFunctionCalledText() throws Exception {
    	response = conversation.getCurrentPage();
    	assertTrue(response.getText().indexOf("function text()") == -1);  	
    }
    */
	public static TestSuite suite() throws Exception {
	    TestSuite suite = new TestSuite();
	    OfflineDocumentSpecs specs = new OfflineDocumentSpecs();
	    DocumentSpec[] all = specs.allSpecs;
	    
	    for (int i = 0; i < all.length; i++) {
	        all[i].setHttpUnitUrl(WebUtils.getApplicationUrl()+
	        		"/analyser/throttlepage?_ab_key=1&_ab_kbps=full&_ab_filt=1");
	    	suite.addTest(all[i].getSuite());	        
	    }
	    return suite;
	}
	
}
