/* ------------------------------------------------------------------------
 * Aidbase simplifies HTML pages to reduce bandwidth usage, et cetera.
 * Copyright (C) 2002-2004 Aidworld Humanitarian ICT, Cambridge, UK. 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 * General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 * This software is intended to be as accessible as possible. If acceptance 
 * of this license conflicts with your interests, please contact us to 
 * discuss how we might be able to accommodate your requirements. 
 * 
 * Please look at our website, http://www.aidworld.org, to find out more 
 * about our organisation and to read our mission statement. 
 * ------------------------------------------------------------------------
 */

package org.aidworld.aidbase.offline.unit;

import junit.framework.Test;
import junit.framework.TestSuite;

import org.aidworld.aidbase.core.BasedTest;

import com.meterware.httpunit.WebForm;
import com.meterware.httpunit.WebResponse;

/**
 * This set of end-to-end tests uses httpunit and is intended to run on a
 * machine with a deployed copy of aidbase running. They can also be run to test
 * a remote copy of aidbase.
 */

public class PostingTests extends BasedTest {
	public PostingTests(String name) {
		super(name);
	}

	public static Test suite() {
		return new TestSuite(PostingTests.class);
	}

	public void testPostingLargePieceOfDataShouldWork() throws Exception {
		char[] testDataArray = new char[256];
		for (int i = 0; i < testDataArray.length; i++) {
			testDataArray[i] = 'a';
		}
		String testDataShortString = new String(testDataArray);

		StringBuffer testStringBuffer = new StringBuffer();
		for (int i = 0; i < 128; i++) {
			testStringBuffer.append(testDataShortString);
			testStringBuffer.append("\n");
		}
		String testString = testStringBuffer.toString();

		WebResponse formPage = getThroughAidbase(getAidbaseUrl()
				+ "/test/postDataTest.jsp");

		WebForm testForm = formPage.getFormWithName("testform");
		assertNotNull("Form testform not found" + testForm);
		testForm.setParameter("bigparam", testString);
		testForm.submit();

		WebResponse resultPage = conversation.getCurrentPage();

		assertFalse("GET instead of POST!", resultPage.getText().indexOf(
				"GET instead of POST!") != -1);
		// String testStringLength = Integer.toString(testString.length());
		assertTrue("Not all characters are passed", resultPage.getText()
				.indexOf(Integer.toString(testString.length())) != -1);
    }	
}
