package org.aidworld.aidbase.offline.unit;

import junit.framework.TestSuite;

import org.aidworld.aidbase.core.BasedTest;
import org.aidworld.aidbase.webui.util.WebUtils;

import com.meterware.httpunit.GetMethodWebRequest;

public class SimulatorTests extends BasedTest{

	public static TestSuite suite()
	{
		return new TestSuite(SimulatorTests.class);
	}
	
    public long TimeGetThrottle (String sUrl, int nSpeed) 
	throws Exception 
	{
    	String sUrl2=sUrl;
    	if(nSpeed>0)
    	{
    		sUrl2=sUrl+ "&_ab_bps=" + nSpeed;
    	}
    	request = new GetMethodWebRequest
    		(WebUtils.getApplicationUrl() + WebUtils.getFilterServletPath() 
			+ "?" +WebUtils.getAidbaseUrlParam() + "=" + sUrl2);
	
    	long ct=System.currentTimeMillis();
    	response = conversation.getResponse( request );
    	long et=System.currentTimeMillis()-ct;
    	return et;    	
}

//  This test fails. Robin is working on the Throttle.    
    public void testSimulatorReturnsPagesAtCorrectSpeed() throws Exception {
    	    	
    	long el1=TimeGetThrottle("file:/CNN.com.html",0);
		long el2=TimeGetThrottle("file:/CNN.com.html",9600);
		long el3=TimeGetThrottle("file:/CNN.com.html",56000);
		long ft2=el2;
		long ft3=el3;
		
    	el2 -= el1;
    	el3 -= el1;
   	
    	int contentlen = response.getText().length();
    	
    	long sp2 = (contentlen * 8000) / el2;
    	long sp3 = (contentlen * 8000) / el3;
    	
    	// allow +- 10% either side of desired speed
    	assertTrue ("Simulated 9.6k speed inaccurate: got " +contentlen+ "bytes in " +ft2 +  "ms ="+sp2 +"bps", sp2>8640 && sp2<10560);
    	assertTrue ("Simulated 56k speed inaccurate: got " +contentlen +"bytes in " + ft3+"ms = "+ sp3+"bps", sp3>54000 && sp3<61600);    	
   }
    
    public void testSimulatorCorrectlyIncludesSpeedParamInLinks() 
	throws Exception {
	
    }
}
