package org.aidworld.aidbase.specialsites;

import java.io.IOException;

import junit.framework.Test;
import junit.framework.TestSuite;

import org.aidworld.aidbase.core.BasedTest;
import org.aidworld.aidbase.webui.util.WebUtils;
import org.apache.log4j.Logger;
import org.xml.sax.SAXException;

public class ReliefwebTests extends BasedTest{

    private Logger LOG = Logger.getLogger (ReliefwebTests.class);

    public static Test suite() {
		return new TestSuite( ReliefwebTests.class );
	}

    /**
     * Loband has its own, simplified, copy of the css file used
     * by reliefweb. This test checks that it is indeed being used.
     * 
     * @throws SAXException
     * @throws IOException
     */
    public void testReliefwebHasLocalCSSFile()
    throws SAXException, IOException
    {
        String text = getThroughAidbase("http://www.reliefweb.int").getText();
        assertTrue("Reliefweb does not have local css", 
                text.indexOf(WebUtils.getContextPath()
                        + "/css/reliefweb.css") != -1);
    }
}
